Index: src/xc/xc_libxc_wrap.F
===================================================================
--- src/xc/xc_libxc_wrap.F	(revision 18250)
+++ src/xc/xc_libxc_wrap.F	(working copy)
@@ -496,58 +312,64 @@
 !> \brief Wrapper for functionals that need special parameters.
 !> \param xc_func ...
 !> \param xc_info ...
-!> \param func_id ...
 !> \param params ...
 !> \param no_exc ...
 !>
-!> \author A. Gloessa (agloess)
+!> \author A. Gloess (agloess)
 ! **************************************************************************************************
-   SUBROUTINE xc_libxc_wrap_functional_set_params(xc_func, xc_info, func_id, params, no_exc)
-      TYPE(xc_f90_pointer_t), INTENT(INOUT)              :: xc_func
-      TYPE(xc_f90_pointer_t), INTENT(IN)                 :: xc_info
-      INTEGER, INTENT(IN)                                :: func_id
-      REAL(KIND=dp), DIMENSION(*), INTENT(IN)            :: params
+   SUBROUTINE xc_libxc_wrap_functional_set_params(xc_func, xc_info, params, no_exc)
+      TYPE(xc_f03_func_t), INTENT(INOUT)                 :: xc_func
+      TYPE(xc_f03_func_info_t), INTENT(IN)               :: xc_info
+      REAL(KIND=dp), DIMENSION(:), INTENT(IN), POINTER   :: params
       LOGICAL, INTENT(INOUT)                             :: no_exc
 
       CHARACTER(LEN=*), PARAMETER :: routineN = 'xc_libxc_wrap_functional_set_params', &
          routineP = moduleN//':'//routineN
 
-      INTEGER                                            :: handle
+      INTEGER                                            :: handle, i_params, n_params
 
       CALL timeset(routineN, handle)
 
-!ToDo: This is dangerous, since wrong parameter ordering or missing ones
-!      result in wrong numbers or a crash.
-!      --> LibXC needs to provide more informations via a function.
-      IF (params(1) < 0.99e20_dp) THEN
-         SELECT CASE (func_id)
-         CASE (XC_LDA_X)
-            CALL xc_f90_lda_x_set_par(xc_func, params(1), NINT(params(2)), params(3))
-         CASE (XC_LDA_C_XALPHA)
-            CALL xc_f90_lda_c_xalpha_set_par(xc_func, params(1))
-         CASE (XC_LDA_C_2D_PRM)
-            CALL xc_f90_lda_c_2d_prm_set_par(xc_func, params(1))
-         CASE (XC_LDA_C_1D_CSC)
-            CALL xc_f90_lda_c_1d_csc_set_par(xc_func, NINT(params(1)), params(2))
-         CASE (XC_LDA_X_1D)
-            CALL xc_f90_lda_x_1d_set_par(xc_func, NINT(params(1)), params(2))
-         CASE (XC_GGA_X_LB)
-            CALL xc_f90_gga_lb_set_par(xc_func, NINT(params(1)), params(2), params(3), params(4))
-         CASE (XC_MGGA_X_TB09)
-            CALL xc_f90_mgga_x_tb09_set_par(xc_func, params(1))
-         CASE (XC_HYB_GGA_XC_HSE03, XC_HYB_GGA_XC_HSE06)
-            CALL xc_f90_hyb_gga_xc_hse_set_par(xc_func, params(1), params(2))
-         CASE (XC_HYB_GGA_XC_HJS_PBE, XC_HYB_GGA_XC_HJS_PBE_SOL, &
-               XC_HYB_GGA_XC_HJS_B88, XC_HYB_GGA_XC_HJS_B97X, &
-               XC_GGA_X_HJS_PBE, XC_GGA_X_HJS_PBE_SOL, &
-               XC_GGA_X_HJS_B88, XC_GGA_X_HJS_B97X)
-            CALL xc_f90_gga_x_hjs_set_par(xc_func, params(1))
-         CASE (XC_GGA_X_WPBEH)
-            CALL xc_f90_gga_x_wpbeh_set_par(xc_func, params(1))
-         END SELECT
+      n_params = xc_f03_func_info_get_n_ext_params(xc_info)
+      i_params = SIZE(params)
+
+      IF ((n_params > 0) .AND. (i_params > 0) .AND. (params(1) < HUGE(0.0_dp))) THEN
+         IF (i_params == n_params) THEN
+            CALL xc_f03_func_set_ext_params(xc_func, params) ! this is wrong, but XC's F90-interface is missing the '*'
+         ELSE
+            CALL cp_abort(__LOCATION__, &
+               "LIBXC: Inconsistent number of optional external parameters. (required: "&
+               &//cp_to_string(n_params)//", given: "//cp_to_string(i_params)//")")
+         END IF
       END IF
 
-      IF (IAND(xc_f90_info_flags(xc_info), XC_FLAGS_HAVE_EXC) == XC_FLAGS_HAVE_EXC) THEN
+!         SELECT CASE (func_id)
+!         CASE (XC_LDA_X)
+!            CALL xc_f03_lda_x_set_par(xc_func, params(1), NINT(params(2)), params(3))
+!         CASE (XC_LDA_C_XALPHA)
+!            CALL xc_f03_lda_c_xalpha_set_par(xc_func, params(1))
+!         CASE (XC_LDA_C_2D_PRM)
+!            CALL xc_f03_lda_c_2d_prm_set_par(xc_func, params(1))
+!         CASE (XC_LDA_C_1D_CSC)
+!            CALL xc_f03_lda_c_1d_csc_set_par(xc_func, NINT(params(1)), params(2))
+!         CASE (XC_LDA_X_1D)
+!            CALL xc_f03_lda_x_1d_set_par(xc_func, NINT(params(1)), params(2))
+!         CASE (XC_GGA_X_LB)
+!            CALL xc_f03_gga_lb_set_par(xc_func, NINT(params(1)), params(2), params(3), params(4))
+!         CASE (XC_MGGA_X_TB09)
+!            CALL xc_f03_mgga_x_tb09_set_par(xc_func, params(1))
+!         CASE (XC_HYB_GGA_XC_HSE03, XC_HYB_GGA_XC_HSE06)
+!            CALL xc_f03_hyb_gga_xc_hse_set_par(xc_func, params(1), params(2))
+!         CASE (XC_HYB_GGA_XC_HJS_PBE, XC_HYB_GGA_XC_HJS_PBE_SOL, &
+!               XC_HYB_GGA_XC_HJS_B88, XC_HYB_GGA_XC_HJS_B97X, &
+!               XC_GGA_X_HJS_PBE, XC_GGA_X_HJS_PBE_SOL, &
+!               XC_GGA_X_HJS_B88, XC_GGA_X_HJS_B97X)
+!            CALL xc_f03_gga_x_hjs_set_par(xc_func, params(1))
+!         CASE (XC_GGA_X_WPBEH)
+!            CALL xc_f03_gga_x_wpbeh_set_par(xc_func, params(1))
+!         END SELECT
+
+      IF (IAND(xc_f03_func_info_get_flags(xc_info), XC_FLAGS_HAVE_EXC) == XC_FLAGS_HAVE_EXC) THEN
          no_exc = .FALSE.
       ELSE
          no_exc = .TRUE.
@@ -557,113 +379,6 @@
 
    END SUBROUTINE xc_libxc_wrap_functional_set_params
 
-! **************************************************************************************************
-!> \brief Wrapper for known buggy functionals.
-!> \param func_id ...
-!> \param grad_deriv ...
-!> \author A. Gloessa (agloess)
-! **************************************************************************************************
-   SUBROUTINE xc_libxc_wrap_functional_buggy(func_id, grad_deriv)
-!
-! BugFix information was taken from:
-!
-! http://www.tddft.org/programs/octopus/wiki/index.php/Libxc_changes
-!
-!
-! corrected with: 2.1.3 and 2.2.3
-!    XC_GGA_X_N12, XC_GGA_C_N12, XC_GGA_C_N12_SX, XC_HYB_GGA_X_N12_SX,
-!    XC_HYB_GGA_XC_O3LYP, XC_HYB_GGA_XC_X3LYP, XC_GGA_X_B88,
-!    XC_GGA_X_OPTB88_VDW, XC_GGA_X_MB88, XC_GGA_K_LLP, XC_GGA_K_FR_B88,
-!    XC_GGA_K_THAKKAR
-! + all XC_GGA_X_HJS_*
-! + all XC_HYB_GGA_XC_HJS_*
-!    second order derivatives (XC_GGA_X_B88, XC_GGA_X_OPTB88_VDW,
-!     XC_GGA_X_MB88, XC_GGA_K_LLP, XC_GGA_K_FR_B88, XC_GGA_K_THAKKAR)
-!
-! corrected with: 3.x.x
-!    XC_MGGA_X_M11, XC_MGGA_X_M11_L, XC_HYB_MGGA_X_MS2H
-!
-!
-! Note, some variables were redefined between version 2.1.x and 3.x.x!
-!
-! XC_HYB_MGGA_X_M11 --> XC_MGGA_X_M11
-! XC_MGGA_X_MS2H    --> XC_HYB_MGGA_X_MS2H
-!
-      INTEGER, INTENT(IN)                                :: func_id
-      INTEGER, INTENT(IN), OPTIONAL                      :: grad_deriv
-
-      CHARACTER(LEN=*), PARAMETER :: routineN = 'xc_libxc_wrap_functional_buggy', &
-         routineP = moduleN//':'//routineN
-
-      CHARACTER(LEN=256)                                 :: func_name
-      INTEGER                                            :: handle, i, my_grad_deriv, nbuggy
-      INTEGER, ALLOCATABLE, DIMENSION(:)                 :: buggy
-      LOGICAL                                            :: bug
-
-      CALL timeset(routineN, handle)
-
-      bug = .FALSE.
-      my_grad_deriv = 0
-      IF (PRESENT(grad_deriv)) my_grad_deriv = ABS(grad_deriv)
-      SELECT CASE (libxc_version)
-#if ( XC_MAJOR_VERSION == 2)
-      CASE ("2.1.2", "2.2.2")
-         IF (my_grad_deriv == 2) THEN
-            nbuggy = 23; ALLOCATE (buggy(nbuggy))
-            buggy(:) = (/XC_GGA_X_N12, XC_GGA_C_N12, &
-                         XC_GGA_C_N12_SX, XC_HYB_GGA_X_N12_SX, XC_HYB_GGA_XC_O3LYP, &
-                         XC_HYB_GGA_XC_X3LYP, XC_GGA_X_B88, XC_GGA_X_OPTB88_VDW, &
-                         XC_GGA_X_MB88, XC_GGA_K_LLP, XC_GGA_K_FR_B88, XC_GGA_K_THAKKAR, &
-                         XC_HYB_MGGA_X_M11, XC_MGGA_X_M11_L, XC_MGGA_X_MS2H, &
-                         XC_GGA_X_HJS_PBE, XC_GGA_X_HJS_PBE_SOL, &
-                         XC_GGA_X_HJS_B88, XC_GGA_X_HJS_B97X, XC_HYB_GGA_XC_HJS_PBE, &
-                         XC_HYB_GGA_XC_HJS_PBE_SOL, XC_HYB_GGA_XC_HJS_B88, XC_HYB_GGA_XC_HJS_B97X/)
-         ELSE
-            nbuggy = 17; ALLOCATE (buggy(nbuggy))
-            buggy(:) = (/XC_GGA_X_N12, XC_GGA_C_N12, &
-                         XC_GGA_C_N12_SX, XC_HYB_GGA_X_N12_SX, XC_HYB_GGA_XC_O3LYP, &
-                         XC_HYB_GGA_XC_X3LYP, &
-                         XC_HYB_MGGA_X_M11, XC_MGGA_X_M11_L, XC_MGGA_X_MS2H, &
-                         XC_GGA_X_HJS_PBE, XC_GGA_X_HJS_PBE_SOL, &
-                         XC_GGA_X_HJS_B88, XC_GGA_X_HJS_B97X, XC_HYB_GGA_XC_HJS_PBE, &
-                         XC_HYB_GGA_XC_HJS_PBE_SOL, XC_HYB_GGA_XC_HJS_B88, XC_HYB_GGA_XC_HJS_B97X/)
-         END IF
-      CASE ("2.1.3", "2.2.3")
-         nbuggy = 3; ALLOCATE (buggy(nbuggy))
-         buggy(:) = (/XC_HYB_MGGA_X_M11, XC_MGGA_X_M11_L, XC_MGGA_X_MS2H/)
 #endif
-      CASE ("3.x.x")
-         nbuggy = 0
-      CASE default
-         nbuggy = 0
-         IF (first_time) THEN
-            CALL cp_warn(__LOCATION__, &
-                         " This version ("//TRIM(libxc_version)//") of LibXC is new or unknown."// &
-                         " ======== Please check the results carefully. ========    "// &
-                         " More informations on bugfixes can be found at: "// &
-                         " http://www.tddft.org/programs/octopus/wiki/index.php/Libxc_changes"// &
-                         " Calculation continues using unsupported LibXC version. ")
-            first_time = .FALSE.
-         END IF
-      END SELECT
-
-      DO i = 1, nbuggy
-         IF (func_id == buggy(i)) THEN
-            bug = .TRUE.
-         END IF
-      END DO
-
-      IF (bug) THEN
-         CALL xc_f90_functional_get_name(func_id, func_name)
-         CALL cp_abort(__LOCATION__, TRIM(func_name)//": deactivated since buggy in version "// &
-                       TRIM(libxc_version)//" of LibXC.")
-      END IF
-
-      IF (ALLOCATED(buggy)) DEALLOCATE (buggy)
-
-      CALL timestop(handle)
-
-   END SUBROUTINE xc_libxc_wrap_functional_buggy
 #endif
-#endif
 END MODULE xc_libxc_wrap
Index: src/xc/xc_rho_set_types.F
===================================================================
--- src/xc/xc_rho_set_types.F	(revision 18250)
+++ src/xc/xc_rho_set_types.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -767,7 +767,7 @@
                   END DO
                   CPABORT("Drho collocation not implemented")
                CASE default
-                  CPABORT("")
+                  CPABORT("Derivatives using PW are not implemented for this 'XC_DERIV'")
                END SELECT
                CALL pw_pool_give_back_pw(pw_pool, tmp_g)
                IF (my_rho_g_local) THEN
Index: src/xc_write_output.F
===================================================================
--- src/xc_write_output.F	(revision 18250)
+++ src/xc_write_output.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -10,8 +10,11 @@
 
    USE input_constants,                 ONLY: xc_none
    USE input_cp2k_check,                ONLY: xc_functionals_expand
-   USE input_section_types,             ONLY: section_vals_get_subs_vals,&
+   USE input_section_types,             ONLY: section_vals_duplicate,&
+                                              section_vals_get,&
+                                              section_vals_get_subs_vals,&
                                               section_vals_get_subs_vals2,&
+                                              section_vals_release,&
                                               section_vals_type,&
                                               section_vals_val_get
    USE kinds,                           ONLY: default_string_length
@@ -45,10 +48,8 @@
       CHARACTER(LEN=10*default_string_length)            :: reference
       CHARACTER(LEN=2*default_string_length)             :: shortform
       CHARACTER(LEN=20)                                  :: tmpStr
-      CHARACTER(LEN=default_string_length), &
-         DIMENSION(:), POINTER                           :: func_name
-      INTEGER                                            :: ifun, ifunc_name, il, myfun
-      TYPE(section_vals_type), POINTER                   :: xc_fun, xc_fun_section
+      INTEGER                                            :: i_rep, ifun, il, myfun, n_rep
+      TYPE(section_vals_type), POINTER                   :: libxc_fun, xc_fun, xc_fun_section
 
       IF (output_unit > 0) THEN
 
@@ -66,26 +67,24 @@
                ifun = ifun+1
                xc_fun => section_vals_get_subs_vals2(xc_fun_section, i_section=ifun)
                IF (.NOT. ASSOCIATED(xc_fun)) EXIT
-               CALL xc_functional_get_info(xc_fun, &
-                                           lsd=lsd, &
-                                           reference=reference, &
-                                           shortform=shortform, &
-                                           ifunc_name=1)
-               IF (TRIM(xc_fun%section%name) == "LIBXC") THEN
-                  CALL libxc_version_info(tmpStr)
-                  WRITE (output_unit, fmt="(A,A,A)") ' FUNCTIONAL| LIBXC Vers. ', TRIM(tmpStr(1:5)), &
-                     ' (Marques, Oliveira, Burnus, CPC 183, 2272 (2012))'
-                  WRITE (output_unit, fmt="(' FUNCTIONAL| ',a,':')") TRIM(shortform)
+               IF (TRIM(xc_fun%section%name) /= "LIBXC") THEN
+                  CALL xc_functional_get_info(xc_fun, lsd=lsd, reference=reference, shortform=shortform)
+                  WRITE (output_unit, fmt="(' FUNCTIONAL| ',a,':')") &
+                     TRIM(xc_fun%section%name)
                   DO il = 1, LEN_TRIM(reference), 67
                      WRITE (output_unit, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
                   END DO
-                  CALL section_vals_val_get(xc_fun, "functional", c_vals=func_name)
-                  DO ifunc_name = 2, SIZE(func_name)
-                     CALL xc_functional_get_info(xc_fun, &
-                                                 lsd=lsd, &
-                                                 reference=reference, &
-                                                 shortform=shortform, &
-                                                 ifunc_name=ifunc_name)
+               ELSE
+                  ! LIBXC is the only repeatable functional section - for each we need
+                  ! NOT the single values, but the whole section_vals_type independently
+                  CALL section_vals_get(xc_fun, n_repetition=n_rep)
+                  DO i_rep = 1, n_rep
+                     NULLIFY (libxc_fun)
+                     CALL section_vals_duplicate(xc_fun, libxc_fun, i_rep_start=i_rep, i_rep_end=i_rep)
+                     IF (.NOT. ASSOCIATED(libxc_fun)) EXIT
+                     CALL xc_functional_get_info(libxc_fun, lsd=lsd, reference=reference, shortform=shortform)
+                     CALL section_vals_release(libxc_fun)
+                     CALL libxc_version_info(tmpStr)
                      WRITE (output_unit, fmt="(A,A,A)") ' FUNCTIONAL| LIBXC Vers. ', TRIM(tmpStr(1:5)), &
                         ' (Marques, Oliveira, Burnus, CPC 183, 2272 (2012))'
                      WRITE (output_unit, fmt="(' FUNCTIONAL| ',a,':')") TRIM(shortform)
@@ -93,12 +92,6 @@
                         WRITE (output_unit, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
                      END DO
                   END DO
-               ELSE
-                  WRITE (output_unit, fmt="(' FUNCTIONAL| ',a,':')") &
-                     TRIM(xc_fun%section%name)
-                  DO il = 1, LEN_TRIM(reference), 67
-                     WRITE (output_unit, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
-                  END DO
                END IF
             END DO
          ELSE
